package com.sun.corba.se.impl.protocol;

import org.omg.CORBA.portable.ServantObject;
import org.omg.CORBA.ContextList;
import org.omg.CORBA.ExceptionList;
import org.omg.CORBA.NamedValue;
import org.omg.CORBA.NVList;
import org.omg.CORBA.Context;
import com.sun.corba.se.impl.corba.RequestImpl;
import org.omg.CORBA.Request;
import org.omg.CORBA.portable.Delegate;
import org.omg.CORBA.CompletionStatus;
import com.sun.corba.se.spi.presentation.rmi.StubAdapter;
import com.sun.corba.se.impl.util.JDKBridge;
import com.sun.corba.se.pept.encoding.InputObject;
import org.omg.CORBA.portable.RemarshalException;
import org.omg.CORBA.portable.ApplicationException;
import com.sun.corba.se.pept.encoding.OutputObject;
import org.omg.CORBA.portable.InputStream;
import com.sun.corba.se.pept.protocol.ClientRequestDispatcher;
import java.util.Iterator;
import com.sun.corba.se.pept.protocol.ClientInvocationInfo;
import com.sun.corba.se.spi.transport.CorbaContactInfoListIterator;
import com.sun.corba.se.spi.transport.CorbaContactInfo;
import org.omg.CORBA.portable.OutputStream;
import org.omg.CORBA.Object;
import com.sun.corba.se.pept.transport.ContactInfoList;
import com.sun.corba.se.pept.broker.Broker;
import com.sun.corba.se.spi.transport.CorbaContactInfoList;
import com.sun.corba.se.impl.logging.ORBUtilSystemException;
import com.sun.corba.se.spi.orb.ORB;
import com.sun.corba.se.spi.protocol.CorbaClientDelegate;

public class CorbaClientDelegateImpl extends CorbaClientDelegate
{
    private ORB orb;
    private ORBUtilSystemException wrapper;
    private CorbaContactInfoList contactInfoList;
    
    public CorbaClientDelegateImpl(ORB orb, CorbaContactInfoList contactInfoList) {
        this.orb = orb;
        this.wrapper = ORBUtilSystemException.get(orb, "rpc.protocol");
        this.contactInfoList = contactInfoList;
    }
    
    public Broker getBroker() {
        return this.orb;
    }
    
    public ContactInfoList getContactInfoList() {
        return this.contactInfoList;
    }
    
    public OutputStream request(Object object, String s, boolean b) {
        ClientInvocationInfo orIncrementInvocationInfo = this.orb.createOrIncrementInvocationInfo();
        Iterator<java.lang.Object> contactInfoListIterator = orIncrementInvocationInfo.getContactInfoListIterator();
        if (contactInfoListIterator == null) {
            contactInfoListIterator = this.contactInfoList.iterator();
            orIncrementInvocationInfo.setContactInfoListIterator(contactInfoListIterator);
        }
        if (!contactInfoListIterator.hasNext()) {
            throw ((CorbaContactInfoListIterator)contactInfoListIterator).getFailureException();
        }
        CorbaContactInfo corbaContactInfo = (CorbaContactInfo)contactInfoListIterator.next();
        ClientRequestDispatcher clientRequestDispatcher = corbaContactInfo.getClientRequestDispatcher();
        orIncrementInvocationInfo.setClientRequestDispatcher(clientRequestDispatcher);
        return (OutputStream)clientRequestDispatcher.beginRequest(object, s, !b, corbaContactInfo);
    }
    
    public InputStream invoke(Object object, OutputStream outputStream) throws ApplicationException, RemarshalException {
        return (InputStream)this.getClientRequestDispatcher().marshalingComplete(object, (OutputObject)outputStream);
    }
    
    public void releaseReply(Object object, InputStream inputStream) {
        this.getClientRequestDispatcher().endRequest(this.orb, object, (InputObject)inputStream);
        this.orb.releaseOrDecrementInvocationInfo();
    }
    
    private ClientRequestDispatcher getClientRequestDispatcher() {
        return ((CorbaInvocationInfo)this.orb.getInvocationInfo()).getClientRequestDispatcher();
    }
    
    public Object get_interface_def(Object object) {
        InputStream invoke = null;
        Object object2 = null;
        try {
            invoke = this.invoke((Object)null, this.request(null, "_interface", true));
            Object read_Object = invoke.read_Object();
            if (!read_Object._is_a("IDL:omg.org/CORBA/InterfaceDef:1.0")) {
                throw this.wrapper.wrongInterfaceDef(CompletionStatus.COMPLETED_MAYBE);
            }
            try {
                object2 = (Object)JDKBridge.loadClass("org.omg.CORBA._InterfaceDefStub").newInstance();
            }
            catch (Exception ex) {
                throw this.wrapper.noInterfaceDefStub(ex);
            }
            StubAdapter.setDelegate(object2, StubAdapter.getDelegate(read_Object));
            return object2;
        }
        catch (ApplicationException ex2) {
            throw this.wrapper.applicationExceptionInSpecialMethod(ex2);
        }
        catch (RemarshalException ex3) {
            return this.get_interface_def(object);
        }
        finally {
            this.releaseReply((Object)null, invoke);
        }
        return object2;
    }
    
    public boolean is_a(Object object, String s) {
        String[] typeIds = StubAdapter.getTypeIds(object);
        if (s.equals(this.contactInfoList.getTargetIOR().getTypeId())) {
            return true;
        }
        int i = 0;
        while (i < typeIds.length) {
            if (s.equals(typeIds[i])) {
                return true;
            }
            ++i;
        }
        InputStream invoke = null;
        try {
            OutputStream request = this.request(null, "_is_a", true);
            request.write_string(s);
            invoke = this.invoke((Object)null, request);
            return invoke.read_boolean();
        }
        catch (ApplicationException ex) {
            throw this.wrapper.applicationExceptionInSpecialMethod(ex);
        }
        catch (RemarshalException ex2) {
            return this.is_a(object, s);
        }
        finally {
            this.releaseReply((Object)null, invoke);
        }
    }
    
    public boolean non_existent(Object object) {
        InputStream invoke = null;
        try {
            invoke = this.invoke((Object)null, this.request(null, "_non_existent", true));
            return invoke.read_boolean();
        }
        catch (ApplicationException ex) {
            throw this.wrapper.applicationExceptionInSpecialMethod(ex);
        }
        catch (RemarshalException ex2) {
            return this.non_existent(object);
        }
        finally {
            this.releaseReply((Object)null, invoke);
        }
    }
    
    public Object duplicate(Object object) {
        return object;
    }
    
    public void release(Object object) {
    }
    
    public boolean is_equivalent(Object object, Object object2) {
        if (object2 == null) {
            return false;
        }
        if (!StubAdapter.isStub(object2)) {
            return false;
        }
        Delegate delegate = StubAdapter.getDelegate(object2);
        return delegate != null && (delegate == this || (delegate instanceof CorbaClientDelegateImpl && this.contactInfoList.getTargetIOR().isEquivalent(((CorbaContactInfoList)((CorbaClientDelegateImpl)delegate).getContactInfoList()).getTargetIOR())));
    }
    
    public boolean equals(Object object, java.lang.Object o) {
        if (o == null) {
            return false;
        }
        if (!StubAdapter.isStub(o)) {
            return false;
        }
        Delegate delegate = StubAdapter.getDelegate(o);
        return delegate != null && delegate instanceof CorbaClientDelegateImpl && this.contactInfoList.getTargetIOR().equals(((CorbaClientDelegateImpl)delegate).contactInfoList.getTargetIOR());
    }
    
    public int hashCode(Object object) {
        return this.hashCode();
    }
    
    public int hash(Object object, int n) {
        int hashCode = this.hashCode();
        if (hashCode > n) {
            return 0;
        }
        return hashCode;
    }
    
    public Request request(Object object, String s) {
        return new RequestImpl(this.orb, object, null, s, null, null, null, null);
    }
    
    public Request create_request(Object object, Context context, String s, NVList list, NamedValue namedValue) {
        return new RequestImpl(this.orb, object, context, s, list, namedValue, null, null);
    }
    
    public Request create_request(Object object, Context context, String s, NVList list, NamedValue namedValue, ExceptionList list2, ContextList list3) {
        return new RequestImpl(this.orb, object, context, s, list, namedValue, list2, list3);
    }
    
    public org.omg.CORBA.ORB orb(Object object) {
        return this.orb;
    }
    
    public boolean is_local(Object object) {
        return this.contactInfoList.getEffectiveTargetIOR().getProfile().isLocal();
    }
    
    public ServantObject servant_preinvoke(Object object, String s, Class clazz) {
        return this.contactInfoList.getLocalClientRequestDispatcher().servant_preinvoke(object, s, clazz);
    }
    
    public void servant_postinvoke(Object object, ServantObject servantObject) {
        this.contactInfoList.getLocalClientRequestDispatcher().servant_postinvoke(object, servantObject);
    }
    
    public String get_codebase(Object object) {
        if (this.contactInfoList.getTargetIOR() != null) {
            return this.contactInfoList.getTargetIOR().getProfile().getCodebase();
        }
        return null;
    }
    
    public String toString(Object object) {
        return this.contactInfoList.getTargetIOR().stringify();
    }
    
    public int hashCode() {
        return this.contactInfoList.hashCode();
    }
}
